-- AutoNo
-- Author: ChaosInc
-- (c) 2009 Joshua Mrozek , All rights reserved.

AutoNo = AutoNo or {}
AutoNo.db = AutoNo.db or {}
AutoNo = CreateFrame("Frame")
AutoNo:RegisterEvent("CHAT_MSG_CHANNEL")
AutoNo:RegisterEvent("VARIABLES_LOADED")
AutoNo:RegisterEvent("ADDON_LOADED")
AutoNo:SetScript("OnEvent", function(self, event, ...) if AutoNo[event] then return AutoNo[event](self, event, ...) end end)
AutoNo:Show()

function AutoNo:ADDON_LOADED()
	self:UnregisterEvent("ADDON_LOADED")
	SLASH_AUTONO1 = "/autono";
	SLASH_AUTONO2 = "/an";
	SlashCmdList["AUTONO"] = function(msg) self:slash(msg) end
end

function AutoNo:VARIABLES_LOADED()
	self:UnregisterEvent("VARIABLES_LOADED")
	AutoNo_RandDB = AutoNo_RandDB or {}
	AutoNo_Vars = AutoNo_Vars or {}
	AutoNo_Vars.enabled = AutoNo_Vars.enabled or true
	AutoNo_Vars.random = AutoNo_Vars.random or false
	-- convert old format to new
	if AUTONO_RANDOM then
		AutoNo_RandDB = CopyTable(AUTONO_RANDOM)
		AUTONO_RANDOM = nil
		print("AutoNo: Random response database successfully converted.")
	end
	if AutoNo_Enabled ~= nil then
		AutoNo_Vars.enabled = AutoNo_Enabled
		AutoNo_Enabled = nil
	end
	if AutoNo_RandomReply ~= nil then
		AutoNo_Vars.random = AutoNo_RandomReply
		AutoNo_RandomReply = nil
	end
	
	-- add rogue support
	if not AutoNo.db.rogue then
		AutoNo.db.rogue = {
		[1] = "I don't have the right key for that one.",
		[2] = "No I'm not gonna pick your nose for you.  Gross.",
		[3] = "A chastitiy belt!?!?  That's gonna chaff my willy...",
		[4] = "Sure thing, but yer gonna have to wait until I get up to that level.",
		[5] = "Sorry, once it's locked up you have to buy a new one.",
		[6] = "You're right. Lox and bagels are tasty indeed!",
		[7] = "I have six locks on my door, all in a row. When I go out, I lock every other one. I figure no matter how long somebody stands there picking the locks, they are always locking three of them.",
		[8] = "Lock, Shock and Barrel?  Does this LOOK like Nightmare Before Christmas?",
		[9] = "Make a rogue, level it up and pick your own damned locks.",
		[10] = "I'm out of seaforium charges.  Better luck next time."
		}
	end
		
	-- add tank/heal support
	if not AutoNo.db.tank then
		AutoNo.db.tank = {
		[1] = "Tanks are made of metal.  Do I look like I'm made of metal?",
		[2] = "What kind of tank?  Water tank?  Fish tank?  Septic tank?!?!",
		[3] = "I left my shield at home.  Sorry.",
		[4] = "Hrm, stand there and get beat on while you hog all the glory as DPS?  I'll pass.",
		[5] = "Can't you see that I'm trying to level my mining?",
		[6] = "My name isn't Thomas, nor am I a blue engine.",
		[7] = "I'm already part of a Think Tank, thanks.  Obviously you're not though...",
		[8] = "WHAT? Come on just one little adjective and we'll have a whole sentence here. The Tank isn't glad. Sad. Mad. Lonely. ",
		[9] = "I don't give lessons.",
		[10] = "My TpS is 10.  Still wanna go?",}
	end
	if not AutoNo.db.heal then
		AutoNo.db.heal = {
		[1] = "Sorry, I'm shadow spec'd.",
		[2] = "Can't help ya.  I'm out of bandages.",
		[3] = "If you would've rolled Draenei you'd have your own heals.",
		[4] = "Sure, 100g per run.",
		[5] = "Get better gear and you won't need heals.",
		[6] = "Sorry, my GearScore isn't above 10k, so I don't meet your requirements.",
		[7] = "HEALS?  WE DON'T NEED NO STINKIN HEALS!!!",
		[8] = "There's called 'P-O-T-I-O-N-S'.  Use those.",
		[9] = "Have you tried looking for pots on the AH?",
		[10] = "I don't waste my time healing practice dummies.",}
	end
end

function AutoNo:CHAT_MSG_CHANNEL(_,msg,_,_,_,_,_,zoneID)
	if (zoneID > 2) or (zoneID == 0) then return end  -- look for general/trade chats only
	table.insert(AutoNo_RandDB, msg)
	if #AutoNo_RandDB >= 21 then
		table.remove(AutoNo_RandDB, 1)
	end
end

function AutoNo:slash(msg)
	local a, b = strsplit(" ", msg);
	if a == "on" then
		print("|c00FF00FFAutoNo:|r -ON-");
		AutoNo_Vars.enabled = true;
	elseif a == "off" then
		print("|c00FF00FFAutoNo:|r -OFF-");
		AutoNo_Vars.enabled = false;
	elseif a == "random" then
		if AutoNo_Vars.random then
			AutoNo_Vars.random = false;
			print("|c00FF00FFAutoNo:|r Random responses disabled.");
		else
			AutoNo_Vars.random = true;
			print("|c00FF00FFAutoNo:|r Random responses enabled.");
		end
	end
end

local function delay(_,elapsed)
	if AutoNo.check then
		AutoNo.delay = AutoNo.delay - elapsed
		if AutoNo.delay <0 then 
			AutoNo.check = false
			AutoNo:SetScript("OnUpdate", nil)
		end
	end
end

--[[ CHECK FRIENDS/GUILD LIST ]]
local function check(author)
	for i = 1, GetNumFriends() do
		local name = GetFriendInfo(i)
		if (name == author) then
			return true
		end
	end
	local guild = GetGuildInfo("player")
	if guild == "" then return false end
	for i = 1, GetNumGuildMembers() do
		local member = GetGuildRosterInfo(i)
		if (author == member) then
			return true
		end
	end
	return false
end

--[[ KEYWORD CHECK ]]
local function keywords(msg)
	if strfind(msg, "water") then
		return "water"
	elseif strfind(msg, "tank") then
		return "tank"
	elseif strfind(msg, "heal") then
		return "heal"
	elseif strfind(msg, "food") then
		return "food"
	elseif strfind(msg, "table") then
		return "table"
	elseif strfind(msg, "summon") then
		return "summon"
	elseif strfind(msg, "porta?l?") then
		if strfind(msg, "dark portal") then return else return "portal" end
	elseif strfind(msg, "lock") then
		if strfind(msg, "warlock") then return else	return "lock" end
	else
		return "none"
	end
end

--[[	FILTER
	Mages: food/water/table/portal
	Warlocks: summon
	Tank: tank
	Healers: heal
	Rogues: lock
	*** return false to show message ***
]]--------------------------------------------------------------
local function filter(_,_,msg,author)
	if not AutoNo_Vars.enabled or check(author) then return false end
	if AutoNo.check then  -- avoid spamming
		AutoNo.delay = 1
		AutoNo:SetScript("OnUpdate", delay)
		return false
	end
	
	msg = string.lower(msg);
	AutoNo.check = true
	
	local word = keywords(msg)
	if word == "none" then return false end
	if AutoNo_Vars.random then
		SendChatMessage(REPLY.. AutoNo_RandDB[math.random(1,#(AutoNo_RandDB))], "WHISPER", nil, author)
		return false
	end
	SendChatMessage(REPLY.. AutoNo.db[word][math.random(1,#(AutoNo.db[word]))], "WHISPER", nil, arg2)
	return false
end

ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER", filter)

